#!/usr/bin/perl

use strict;
use warnings "all";

if (!defined($ARGV[1])) {
	print STDERR "clustered_edgelist.pl PROTEINORTHO_OUTFILE EDGELIST >CLUSTERED_EDGELIST \nReads Proteinortho outfile and its initial edge list and calculates\nthe remaining edge list after the step of clustering.\n";
	exit;
}


# Proteinortho Output
my @result;
open(IN,"<$ARGV[0]") || die("Could not open file $ARGV[0]: $!");
while (<IN>) {
	if ($_ =~ /^#/) {next;}
	chomp;
	my @data = split;
	shift(@data); 	shift(@data);	shift(@data);
	my @res;
	foreach (@data) {if ($_ ne "*") {push(@res,$_);}}
	push(@result,\@res);
}
close(IN);

# Edgelist
open(IN,"<$ARGV[1]") || die("Could not open file $ARGV[1]: $!");
while (<IN>) {
	chomp;
	my @data = split;
	if (!defined($data[1])) {next;}
	foreach (@result) {
		my $match = 0;
		foreach (@{$_}) {
			if ($_ eq $data[0] || $_ eq $data[1]) {$match++;}
		}
		if ($match == 1) {last;}
		elsif ($match == 2) {print join("\t",@data)."\n"; last;}
	}
}
close(IN);
